const colors = require('colors');

/**
    black    red    green    yellow    blue    magenta    cyan
    white    gray    grey
    bgBlack    bgRed    bgGreen    bgYellow    bgBlue
    bgMagenta    bgCyan    bgWhite

    bold    italic    underline    strikethrough

    //vscode中，已验证：仅普通前景色，bold和underline有效。其他风格和背景都无效。
    //windows console中，已验证：普通前景色，bold和背景色都有效
*/

let isTty = console._stdout._type === 'tty';//isTty: 是windows原生的console

colors.setTheme({
    prompt: 'gray', //命令行的起始部分
    info: 'green', //提示信息
    hint: ['yellow', 'italic'], //内嵌的提示信息
    warn: ['bgMagenta', 'grey'], //警告信息，突出部分
    err: ['red', 'bold'], //错误信息
    title: ['magenta', 'bgYellow'], //标题部分
    data: ['cyan', 'bgBlue'], //数据部分
    stack: ['magenta', 'bgWhite'], //跟踪信息
});

if (!isTty)//vscode集成调试器
    colors.setTheme({
        title: ['blue', 'bold'], //标题部分        
        warn: 'magenta', //警告信息，突出部分
        stack: ['cyan', 'bold'], //跟踪信息        
    });



// https://blog.csdn.net/autumn84/article/details/44816947

//  String.prototype.__defineGetter__('focus', function(){
//      return this.yellow.bold.underline.italic;//只有颜色有效果
//  });