//格式化日期。D: yyyy-MM-dd, T: hh:mm:ss, "L": yyyy-MM-dd hh:mm:ss, "D-": yyyyMMdd, "T-": hhmmss, "L-": yyyyMMdd hhmmss
Date.prototype.toString = function (format) {
    return this.fmt(format);
};

//格式化日期。D: yyyy-MM-dd, T: hh:mm:ss, "L": yyyy-MM-dd hh:mm:ss, "D-": yyyyMMdd, "T-": hhmmss, "L-": yyyyMMdd hhmmss
Date.prototype.fmt = function (format) {
    if (!this || this.getTime() === 0)
        return undefined;
    if (!format)
        format = 'L';
    var f = format.toLocaleUpperCase();
    if (f == 'D')
        return this.fmt('yyyy-MM-dd');
    else if (f == 'T')
        return this.fmt('hh:mm:ss');
    else if (f == 'L')
        return this.fmt('yyyy-MM-dd hh:mm:ss');
    else if (f == 'D-')
        return this.fmt('yyyyMMdd');
    else if (f == 'T-')
        return this.fmt('hhmmss');
    else if (f == 'L-')
        return this.fmt('yyyyMMdd hhmmss');
    else if (f == 'F')
        return this.fmt('yyyy-MM-dd hh:mm:ss.fff');

    var reg = {
        "(M+)": this.getMonth() + 1, //month 
        "(d+)": this.getDate(), //day 
        "(h+)": this.getHours(), //hour 
        "(H+)": this.getHours(), //hour 
        "(m+)": this.getMinutes(), //minute 
        "(s+)": this.getSeconds(), //second 
        "(q+)": Math.floor((this.getMonth() + 3) / 3), //quarter 
        "(f+)": this.getMilliseconds() //millisecond 
    }

    if (/(y+)/.test(format)) {
        format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    }

    if (/(f+)/.test(format)) {
        format = format.replace(RegExp.$1, (this.getMilliseconds() + "").substr(3 - RegExp.$1.length));
    }

    for (var k in reg) {
        if (new RegExp(k).test(format)) {
            format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? reg[k] : ("00" + reg[k]).substr(("" + reg[k]).length));
        }
    }
    return format;
};

// 返回日期与参数日期的时间差，unit: d：天，h：小时, m：分钟, s：秒, ms：毫秒（默认）
Date.prototype.subs = function (otherDate, unit) {
    if (unit == 'd') return this.getDate() - (otherDate ? otherDate.getDate() : 0);
    var diff = this.getTime() - (otherDate ? otherDate.getTime() : 0);
    if (!unit || unit == 'ms') return diff;
    diff /= 1000;
    if (unit == 's') return parseInt(diff);
    diff /= 60;
    if (unit == 'm') return parseInt(diff);
    diff /= 60;
    if (unit == 'h') return parseInt(diff);
    throw Exception('错误的日期差值单位: ' + unit);
};

//给日期增加或者减少指定的月份数，返回修改后的新对象（老对象不变）
Date.prototype.addMonth = function (count) {
    var n = new Date(this);
    n.setMonth(n.getMonth() + count);
    return n;
}

//给日期增加或者减少指定的天数，返回修改后的新对象（老对象不变）
Date.prototype.addDay = function (count) {
    var n = new Date(this);
    n.setDate(n.getDate() + count);
    return n;
}