const wcl = require('./wcl');
const StringBuilder = require('./stringBuilder');

//忽略大小写
String.prototype.sameText = function (other) {
    if (!other)
        return false;
    return this.toLocaleLowerCase() == other.toLocaleLowerCase();
};

//用单引号括起来
String.prototype.__defineGetter__('q', function () {
    return "'" + this + "'";
});

//用双引号括起来
String.prototype.__defineGetter__('qq', function () {
    return '"' + this + '"';
});

//使用自定义函数或者对象的属性列表填充格式化的字符串
String.prototype.fmt = function (spliter, funsOrObjs) {
    var spliters = '{}``@@##$$%%&&??()<>[]';
    var si = typeof spliter == wcl.cst.str && spliter.length == 1 ? spliters.indexOf(spliter) : -1;
    var base = 0;
    if (si < 0)
        si = 0;//使用默认spliter，此时spliter参数被视作忽略
    else
        base = 1;
    var left = spliters[si];
    var right = spliters[si + 1];

    var result = new StringBuilder();

    var i = 0;
    var name = '';
    var format = '';

    var args = arguments;
    if (args.length == base + 1 && wcl.isArray(args[base])) {
        args = args[base];
        base = 0;
    }
    var getValue = function () {
        var value;
        var subname = name.right('.');
        subname && (name = name.left('.') || '0');
        if (!isNaN(name))
            value = args[parseInt(name) + base];
        else
            for (var i = base; i < args.length; i++) {
                if (wcl.isFunction(args[i]) && (value = args[i](name, format)) !== undefined)
                    break;
                else if (args[i] && (value = args[i][name]) !== undefined)
                    break;
            }
        return wcl.fmtValue(subname && value != undefined ? value[subname] : value, format);
    }

    var isName = 1;
    var isFormat = 2;
    var isStart = isSource = 0;

    while (i < this.length) {
        var char = this[i];
        if (isStart) {
            if (isStart == isName && char == ':')
                isStart = isFormat;
            else if (char == right) {
                isStart = isSource;
                name = name && name.trim();
                format = format && format.trim(true);
                result.append(getValue());
                name = '';
                format = '';
            }
            else if (isStart == isName)
                name += char;
            else
                format += char;
        }
        else if (char == left && this[i + 1] == left) {
            result.append(left);
            i++;
        }
        else if (char == left)
            isStart = isName;
        else
            result.append(char);
        i++;
    }

    return result.toString();
}

//取字符串左长度，或者分隔符左边的字串。noFindAsEmpty: 默认false
String.prototype.left = function (find, noFindAsEmpty) {
    if (typeof find == wcl.cst.str) {
        var idx = this.indexOf(find);
        if (idx >= 0)
            return this.substr(0, idx);
        else
            return noFindAsEmpty ? "" : this.toString();
    }
    else
        return this.substr(0, find > 0 ? find : this.length + find);
};

//取字符串右长度，或者分隔符右边的字串。noFindAsEmpty：默认true
String.prototype.right = function (find, noFindAsEmpty) {
    if (typeof find == wcl.cst.str) {
        if (noFindAsEmpty == undefined)
            noFindAsEmpty = true;
        var idx = this.indexOf(find);
        if (idx >= 0)
            return this.substr(idx + find.length);
        else
            return noFindAsEmpty ? "" : this.toString();
    }
    else
        return this.substr(this.length - find, find);
};

//根据参数指定，删除字符串的首位空白。（未指定参数则首尾都删除）
String.prototype.trim = function (trimLeft, trimRight) {
    if (arguments.length == 0 || (trimLeft && trimRight))
        return this.replace(/(^\s*)|(\s*$)/g, "");
    else if (trimLeft)
        return this.replace(/^\s*/g, "");
    else if (trimRight)
        return this.replace(/\s*$/g, "");
    return this;
}

//将字符串转换成日期
String.prototype.toDate = function () {
    // return new Date(this.replace('-', '/'));
    let val = this.valueOf();
    if (val === '')
        return new Date(0);
    return new Date(val);
}

/**
 * 返回删除指定位置之后的新字符串
 * @param  {Number} start 起始位置
 * @param  {Number} end 结束位置
 * @returns {String}
 */
String.prototype.remove = function (start, end) {
    if (end < start)
        return this.toString();
    return this.substr(0, start) + this.substr(end + 1, this.length - end - 1);
}