//【该类不依赖其他本地代码，可以单独剥离。】
//利用数组的join优化字符串连接。多用于频繁连接字符串的情况下。
class stringBuilder {
    constructor() {
        /**@type {String[]} */
        this.arr = [];
    }

    appendOne(val) {
        this.arr.push(val);
        return this;
    }

    append(...val) {
        this.arr.push(...val);
        return this;
    }

    appendLine(...val) {
        this.arr.push(...val, '\r\n');
        return this;
    }

    backChar(count) {
        if (!count)
            return this.back(1);
        this.arr.trim();
        if (this.arr.length === 0)
            return this;

        let last = this.arr.last();
        if (last.length == count)
            this.arr.pop();
        else if (last.length < count) {
            this.arr.pop();
            this.back(count - last.length);
        }
        else
            this.arr.last(last.substr(0, last.length - count));

        return this;
    }

    back(count) {
        count || (count = 1);
        this.arr.trim();
        for (let i = 0; i < count; i++) {
            this.arr.pop();
        }
        return this;
    }

    clear() {
        this.arr = [];
        return this;
    }

    setCol(colObj) {
        this.colObj = colObj;
        return this;
    }

    fld(fldObj, opr, val) {
        if (arguments.length === 2) {
            val = opr;
            opr = '=';
        }
        let col = this.colObj;
        if (fldObj.fieldName) {
            col = fldObj;
            fldObj = fldObj.fieldName;
        }
        else {
            fldObj = String(fldObj);
            let find = _.find(i => i.fieldName === fldObj);
            // for (const key in col) {
            //     const elem = col[key];
            //     if (elem.fieldName === fldObj) {
            //         find = elem;
            //         break;
            //     }
            // }
            if (!find)
                throw `字段定义'${fldObj}'不存在`;
            col = find;
        }
        this.append('[' + fldObj + '] ', opr, ' ', col ? col.valuePart(val) : val);
        return this;
    }

    and(fldObj, opr, val) {
        if (arguments.length === 2) {
            val = opr;
            opr = '=';
        }
        this.append(' and ');
        this.fld(fldObj, opr, val);
        return this;
    }

    andStart(fldObj, opr, val) {
        if (arguments.length === 2) {
            val = opr;
            opr = '=';
        }
        this.append(' and (');
        this.fld(fldObj, opr, val);
        return this;
    }

    or(fldObj, opr, val) {
        if (arguments.length === 2) {
            val = opr;
            opr = '=';
        }
        this.append(' or ');
        this.fld(fldObj, opr, val);
        return this;
    }

    orStart(fldObj, opr, val) {
        if (arguments.length === 2) {
            val = opr;
            opr = '=';
        }
        this.append(' or (');
        this.fld(fldObj, opr, val);
        return this;
    }

    jEnd() {
        return this.append(')');
    }

    toString() {
        return this.arr.join('');
    }
}

stringBuilder.add = stringBuilder.append;

module.exports = stringBuilder;